
    .text
    .global convert_32bpp_to_16bpp
    .align 2

x001f001f:
    .word 0x001f001f

convert_32bpp_to_16bpp:
    mov    ip, sp
    stmfd  sp!, { r4-r8, fp, ip, lr, pc }
    sub     fp, ip, #4
    
    ldr r7, x001f001f
    mov r8, #0x000003e0

    @ r0 = input address (32bpp, word-aligned)
    @ r1 = output address (16bpp, word-aligned)
    @ r2 = number of pixels (must be even)

1:
    @ read and pack first pixel
    ldr       r5, [r0], #4        @ bbbbbXXX ggggggXX rrrrrXXX
    and       r3, r7, r5, lsr #3  @ ...bbbbb ........ ...rrrrr
    orr       r3, r3, r3, lsr #5  @ ...XXXXX bbbbb... ...rrrrr
    and       r4, r8, r5, lsr #6  @ ........ .....ggg ggg.....
    orr       r5, r3, r4          @ ...XXXXX bbbbbggg gggrrrrr

    @ read and pack second pixel
    ldr       r6, [r0], #4        @ bbbbbXXX ggggggXX rrrrrXXX
    and       r3, r7, r6, lsr #3  @ ...bbbbb ........ ...rrrrr
    orr       r3, r3, r3, lsr #5  @ ...XXXXX bbbbb... ...rrrrr
    and       r4, r8, r6, lsr #6  @ ........ .....ggg ggg.....
    orr       r6, r3, r4          @ ...XXXXX bbbbbggg gggrrrrr

    @ combine and write both pixels to output
    bic       r5, r5, #0x00ff0000
    orr       r5, r5, r6, asl #16
    str       r5, [r1], #4

    @ decrement pixel count and loop
    subs      r2, r2, #2
    bne       1b

    ldmfd  sp, { r4-r8, fp, sp, pc }

