#include "convert_32bpp_to_16bpp.h"

#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/fcntl.h>

typedef unsigned char u8;
typedef unsigned short u16;

struct rgba
{
	u8 r, g, b, a;
};

int main(void)
{
	int fd = open( "/dev/mem", O_RDWR );
	void *screen = mmap( 0, 320*240*2, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0x03101000);
	volatile short *io = (volatile short *)mmap( 0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0xc0000000);
	
	io[0x28da>>1] = 0x04ab; // 16bpp
	io[0x290c>>1] = 640;    // 320 pixel stride

	struct rgba data_32bpp[320*240];
	u16 data_16bpp[320*240];

	for( int y = 0; y < 240; ++y )
	{
		for( int x = 0; x < 320; ++x )
		{
			struct rgba &pixel = data_32bpp[320*y+x];
			pixel.r = y;
			if( x < 160 )
			{
				pixel.g = (u8)((160-x) * (255.0f / 160.0f) + 0.5f);
				pixel.b = 0;
			}
			else
			{
				pixel.g = 0;
				pixel.b = (u8)((x-160) * (255.0f / 160.0f) + 0.5f);
			}
			pixel.a = 0;
		}
	}

	convert_32bpp_to_16bpp( data_32bpp, data_16bpp, 320*240 );

	memcpy( screen, data_16bpp, 320*240*2 );

	return 0;
}

